#!/usr/bin/perl

use strict;
package QBlocker;

my @erlaubt;
my @ignored;
my $blocked = 0;

###################################################################
# Hier bitte die Notwendigen Einstellungen vornehmen
# Modify these text messages for your needs.
###################################################################

# Diese Nachricht wird dem User angezeigt, der dich anqueryt.
#This message is sent to the user which is blocked
my $deny_message = "Automatic Ignore: You are ignored for 60 seconds now.";
# Diese Nachricht wird dem User angezeigt, wenn du ihm den erfragten Query erlaubst.
# This message is sent to a user which is allowed immediately to query you.
my $allow_message = "Automatic answer: Query allowed!";

###################################################################
# Ab hier bitte nur ndern, wenn du weisst, was du tust!
###################################################################
my $scriptname = "GodOfGTA's Query Blocker modif by Zap-Zarerap - made usable by gargelkarg+checkit - improved by DocTrax";
my $version = "1.36_english";
my $home = IRC::get_info(4);
my $confpath = $home."/queryblocker.conf";
my $ignoredpath = $home."/queryblocker.ignored";
my $logpath = $home."/queryblocker.log";
my $setlog = 1;
IRC::register ($scriptname, $version, "", "");
IRC::add_command_handler("qb", "QBlocker::qb_on_off");
IRC::add_command_handler("qballow", "QBlocker::erlauben");
IRC::add_command_handler("qbdeny", "QBlocker::nichterlauben");
IRC::add_command_handler("qballowlist", "QBlocker::allowliste");
IRC::add_command_handler("qbhelp", "QBlocker::hilfesystemen");
IRC::add_command_handler("query", "QBlocker::eigenerquery");
IRC::add_command_handler("qbblocked", "QBlocker::zeigblock");
IRC::add_command_handler("qbsetlog", "QBlocker::setlog");
IRC::add_command_handler("qbclearlog", "QBlocker::clearlog");
IRC::add_command_handler("qbignore", "QBlocker::ignores");
IRC::add_command_handler("qbignorelist", "QBlocker::ignorelist");
IRC::add_command_handler("qbunignore", "QBlocker::unignore");
IRC::add_message_handler("PRIVMSG" , "QBlocker::auto_answer");
IRC::print(chr(3) . "5,8QueryBlocker\t". $version ." is loaded and activated!" . chr(3));
IRC::print(chr(3) . "4,8To deactivate it /qb For English help type /qbhelpen" . chr(3));
my $qbs = 1;
my $letzternick;
my $ignorenick;
&load_conf();
&load_ignored();

sub check_in_list 
{
	my $nick = join (" ", @_ );
	if(uc($_) eq uc(IRC::get_info(1)))
	{
		return -2;
	}
	my $cnt = 0;
	foreach  (@erlaubt) 
	{
		if (uc($_) eq uc($nick))
		{
			return $cnt;
		}
		$cnt++;
	}
	return -1;
}

sub check_ignore
{
	my $nick = join (" ", @_ );
	if(uc($_) eq uc(IRC::get_info(1)))
	{
		return -2;
	}
	my $cnt = 0;
	foreach  (@ignored) 
	{
		if (uc($_) eq uc($nick)) 
		{
			return $cnt;
		}
		$cnt++;
	}
	return -1;
}

sub setlog
{
	if ($setlog)
	{
		IRC::print("Logging is _OFF_ now.");
		$setlog = 0;
		return 1;
	}
	else
	{
		IRC::print("Logging is _ON_ now.");
		$setlog = 1;
		return 1;
	}
}

sub zeigblock
{
	IRC::print("There are ".$blocked." queries. See Logfile ". $logpath ." for details.\nCounter has been resetted! Log remains.");
	$blocked = 0;
}

sub eigenerquery 
{
	my $line = join ( " " , @_);
	if($qbs==1) 
	{
		if (&check_in_list($line) == -1) 
		{
			push(@erlaubt,$line);
		}
		&save_conf();
	}
	return 0;
}

sub erlauben 
{
	my $nick = @_[0];
	$nick =~ s/\s+$//;
	IRC::print("There have not been any blocked queries since the last check.") unless ($blocked);
	IRC::print("There have been ". $blocked ." blocked queries since the last check.") if ($blocked);
	if ($qbs==1) 
	{
		if ( $nick ) 
		{
			if (&check_in_list($nick) == -1) 
			{
				&unignore($nick) if (&check_ignore($nick) >= 0);
				push(@erlaubt,$nick);
			}
			else
			{
				&unignore($nick) if (&check_ignore($nick) >= 0);
				IRC::print($nick." is still in the allow list.");
			}
		}
		else 
		{
			if(!$letzternick) 
			{
				return 1;
			}
			push(@erlaubt,$letzternick) if (&check_in_list( $nick ) == -1);
			IRC::command("/query " . $letzternick);
			IRC::command("/msg " . $letzternick ." ". $allow_message);
		}
		&save_conf();
	}
	return 1;
}

sub ignores
{
	my $nick = @_[0];
	$nick =~ s/\s+$//;
	IRC::print("There have not been any blocked queries since the last check.") unless ($blocked);
	IRC::print("There have been ". $blocked ." blocked queries since the last check.") if ($blocked);
	if ($qbs==1) 
	{
		if ($nick) 
		{
			if ((&check_in_list($nick) >= 0) && (&check_ignore($nick) < 0))
			{
				push(@ignored,$nick);
				&nichterlauben($nick);
				IRC::print($nick." was in the allow list and is now in the ingnore list.");
			}
			elsif(&check_ignore($nick) >= 0)
			{
				&nichterlauben($nick) if (&check_in_list($nick) >= 0);
				IRC::print($nick." is still in the ignore list.");
			}
			else
			{
				&nichterlauben($nick) if (&check_in_list($nick) >= 0);
				push(@ignored,$nick);
				IRC::print($nick." is now in the ignore list.");
			}
		}
		else 
		{
			if(!$letzternick) 
			{
				return 1;
			}
			push(@erlaubt,$letzternick) if (&check_in_list($nick) == -1);
		}
		&save_ignored();
	}
	return 1;
}

sub nichterlauben
{
	my $nick = @_[0];
	$nick =~ s/\s+$//;
	my $idx;
	my $temp;

	if ($qbs==1) 
	{
		if($nick ne "") 
		{
			$idx = &check_in_list( $nick );
			if ( $idx == -1) 
			{
				IRC::print($nick." is not in the allow list.");
				return 1;
			}
			else 
			{
				$temp = splice(@erlaubt,$idx,1) if ($idx>=0);
			}
		}
		else
		{
			$temp = pop(@erlaubt);
		}
		IRC::print("The queries from ". $temp. " are blocked again.");
		&save_conf();
	}
	return 1;
}

sub unignore
{
	my $nick = join (" ", @_);
	my $temp;
	if ($qbs==1) 
	{
		if($nick ne "") 
		{
			my $idx = &check_ignore( $nick );
			if ( $idx == -1) 
			{
				IRC::print( $nick." is not in the ignore list.");
				return 1;
			}
			else 
			{
				$temp = splice(@ignored,$idx,1) if ($idx>=0);
			}
		}
		else 
		{
			$temp = pop(@ignored);
		}
		IRC::print($temp. " is not longer ignored.");
		&save_ignored();
	}
	return 1;
}

sub allowliste 
{
	my $schleife= 0;
	my $temp;
	IRC::print("These users are allowed to query you:\n");
	foreach $temp (@erlaubt) 
	{
		IRC::print("(".$schleife.") ".$temp);
		$schleife++; 
	}
	return 1;
}

sub ignorelist
{
	my $schleife= 0;
	my $temp;
	IRC::print("These users are completly ignored by Queryblocker:\n");
	foreach $temp (@ignored) 
	{
		IRC::print("(".$schleife.") ".$temp);
		$schleife++; 
	}
	return 1;
}

sub qb_on_off {
	if($qbs == 1) 
	{
		IRC::print("The Query-Blocker is now deactivated!\nTo reactivate it type /qb again.");
		$qbs = 0;
		return 1; 
	}
	else  
	{
		IRC::print("The Query-Blocker is activated now!\nTo deacivate it type /qb again");
		$qbs = 1;
		return 1; 
	}
}

sub auto_answer 
{
	if ($qbs != 0)
	{
		my $temp;
		my $line = join ( " ", @_);
		my $MyName = ( IRC::get_info(1) );
		if($line =~ m/:(.*?)\!.*? PRIVMSG $MyName :(.*)/) 
		{
			my $QUser = $1;
			my $second = 1;
			$second = 0 if ($QUser eq $letzternick);
			$letzternick = $1;
			my $QMessage = $2;
			return 0 if ( &check_in_list ( $QUser )  != -1 );
			IRC::print( chr(3) ."4,10>" . $QUser ."<\t". chr(3) . "1,10is quering you: " . chr(3) . "2,10::" . $QMessage . chr(3) . "2,10 ::" );
			IRC::command("/msg ". $QUser ." ". $deny_message ) if ( ( &check_ignore( $QUser ) == -1 ) && ($second) );
			$blocked++;
			&save_log( $QUser." == ".$QMessage ) if ($setlog);
			return 1; 
		}
		else 
		{
			return 0; 
		} 
	}
	else 
	{
		return 0; 
	}
}

sub hilfesystemen
{
	IRC::print( chr(3) . "2,8".$scriptname."---------------------------------------- v".$version. chr(3) );
	IRC::print( chr(3) . "5,8Commands: ". chr(3) );
	IRC::print( chr(3) . "5,8/qb\t-> Toggeles the Queryblocker on or off.". chr(3) );
	IRC::print( chr(3) . "5,8/qballow\t-> Allows a query for the last user trying to query you." . chr(3) );
	IRC::print( chr(3) . "5,8/qballow nick\t-> Allows a query for user nick." . chr(3) );
	IRC::print( chr(3) . "5,8/qballowlist\t-> Shows the list of users which are allowed to query you" . chr(3) );
	IRC::print( chr(3) . "5,8/qbdeny\t-> Blocks the last user (in list) again." . chr(3) );
	IRC::print( chr(3) . "5,8/qbdeny nick\t-> Blocks the user nick again." . chr(3) );
	IRC::print( chr(3) . "5,8/qbignore\t-> Ignores the last user tried to auery you completly." . chr(3) );
	IRC::print( chr(3) . "5,8/qbignore nick\t-> Ingores user nick completely." . chr(3) );
	IRC::print( chr(3) . "5,8/qbignorelist\t-> Shows the list of users which are completly ignored by the script." . chr(3) );
	IRC::print( chr(3) . "5,8/qbunignore\t-> The last user in list is not longer ignored." . chr(3) );
	IRC::print( chr(3) . "5,8/qbunignore nick\t-> User nick is not longer ignored." . chr(3) );
	IRC::print( chr(3) . "5,8/qbblocked\t-> Shows the amount of blocked queries." . chr(3) );
	IRC::print( chr(3) . "5,8/qbsetlog\t-> Toggles logging on or off." . chr(3) );
	IRC::print( chr(3) . "5,8/qbclearlog\t-> Deletes the log file. Take care!" . chr(3) );
	IRC::print( chr(3) . "5,8/qbhelpen\t-> This help message :)" . chr(3) );
	IRC::print( chr(3) . "5,8... and queryblocker.log stores the blocked msgs." . chr(3) );
	return 1;
}

sub load_conf 
{
	open (CONF, "<$confpath");
	if ( -f CONF) 
	{
		while (<CONF>) 
		{
			chop;
			push (@erlaubt, $_);
		}
		close CONF;
		IRC::print( chr(3) . "7,8Config file ".$confpath." loaded" . chr(3));
	}
	else
	{
		IRC::print( chr(3) . "7,8Fatal: Config file ".$confpath." not found! File created." . chr(3));
	}
}

sub save_conf 
{
	open (CONF, ">".$confpath);
	if ( -f CONF) 
	{
		foreach (@erlaubt) 
		{
			print CONF $_."\n";
		}
		close CONF;
	}
}

sub load_ignored 
{
	open (CONF, "<$ignoredpath");
	if ( -f CONF) 
	{
		while (<CONF>) 
		{
			chop;
			push (@ignored, $_);
		}
		close CONF;
		IRC::print( chr(3) . "7,8Config file ".$ignoredpath." loaded" . chr(3));
	}
	else
	{
		IRC::print( chr(3) . "7,8Fatal: Config file ".$ignoredpath." not found! File created." . chr(3));
	}
}


sub save_ignored
{
	open (CONF, ">".$ignoredpath);
	if ( -f CONF) 
	{
		foreach (@ignored) 
		{
			print CONF $_."\n";
		}
		close CONF;
	}
}

sub save_log
{
	open (LOG, ">>".$logpath);
	if ( -f LOG) 
	{
		print LOG join (" ", @_) ."\n";
		close LOG;
	}
}

sub clearlog
{
	open (LOG, ">".$logpath);
	IRC::print("The Log is cleared now.");
}
